package sun.awt;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.LayoutManager;

public class HorizBagLayout implements LayoutManager {
   int hgap;

   public HorizBagLayout() {
      this(0);
   }

   public HorizBagLayout(int var1) {
      this.hgap = var1;
   }

   public void addLayoutComponent(String var1, Component var2) {
   }

   public void removeLayoutComponent(Component var1) {
   }

   public Dimension minimumLayoutSize(Container var1) {
      Dimension var2 = new Dimension();

      for(int var3 = 0; var3 < var1.countComponents(); ++var3) {
         Component var4 = var1.getComponent(var3);
         if (var4.isVisible()) {
            Dimension var5 = var4.minimumSize();
            var2.width += var5.width + this.hgap;
            var2.height = Math.max(var5.height, var2.height);
         }
      }

      Insets var6 = var1.insets();
      var2.width += var6.left + var6.right;
      var2.height += var6.top + var6.bottom;
      return var2;
   }

   public Dimension preferredLayoutSize(Container var1) {
      Dimension var2 = new Dimension();

      for(int var3 = 0; var3 < var1.countComponents(); ++var3) {
         Component var4 = var1.getComponent(var3);
         if (var4.isVisible()) {
            Dimension var5 = var4.preferredSize();
            var2.width += var5.width + this.hgap;
            var2.height = Math.max(var2.height, var5.height);
         }
      }

      Insets var6 = var1.insets();
      var2.width += var6.left + var6.right;
      var2.height += var6.top + var6.bottom;
      return var2;
   }

   public void layoutContainer(Container var1) {
      Insets var2 = var1.insets();
      int var3 = var2.top;
      int var4 = ((Component)var1).size().height - var2.bottom;
      int var5 = var2.left;
      ((Component)var1).size();

      for(int var6 = 0; var6 < var1.countComponents(); ++var6) {
         Component var7 = var1.getComponent(var6);
         if (var7.isVisible()) {
            int var8 = var7.size().width;
            var7.resize(var8, var4 - var3);
            Dimension var9 = var7.preferredSize();
            var7.reshape(var5, var3, var9.width, var4 - var3);
            var5 += var9.width + this.hgap;
         }
      }

   }

   public String toString() {
      return this.getClass().getName() + "[hgap=" + this.hgap + "]";
   }
}
