package sun.awt;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.LayoutManager;

public class VerticalBagLayout implements LayoutManager {
   int vgap;

   public VerticalBagLayout() {
      this(0);
   }

   public VerticalBagLayout(int var1) {
      this.vgap = var1;
   }

   public void addLayoutComponent(String var1, Component var2) {
   }

   public void removeLayoutComponent(Component var1) {
   }

   public Dimension minimumLayoutSize(Container var1) {
      Dimension var2 = new Dimension();
      int var3 = var1.countComponents();

      for(int var4 = 0; var4 < var3; ++var4) {
         Component var5 = var1.getComponent(var4);
         if (var5.isVisible()) {
            Dimension var6 = var5.minimumSize();
            var2.width = Math.max(var6.width, var2.width);
            var2.height += var6.height + this.vgap;
         }
      }

      Insets var7 = var1.insets();
      var2.width += var7.left + var7.right;
      var2.height += var7.top + var7.bottom;
      return var2;
   }

   public Dimension preferredLayoutSize(Container var1) {
      Dimension var2 = new Dimension();
      int var3 = var1.countComponents();

      for(int var4 = 0; var4 < var3; ++var4) {
         Component var5 = var1.getComponent(var4);
         Dimension var6 = var5.preferredSize();
         var2.width = Math.max(var6.width, var2.width);
         var2.height += var6.height + this.vgap;
      }

      Insets var7 = var1.insets();
      var2.width += var7.left + var7.right;
      var2.height += var7.top + var7.bottom;
      return var2;
   }

   public void layoutContainer(Container var1) {
      Insets var2 = var1.insets();
      int var3 = var2.top;
      ((Component)var1).size();
      int var4 = var2.left;
      int var5 = ((Component)var1).size().width - var2.right;
      int var6 = var1.countComponents();

      for(int var7 = 0; var7 < var6; ++var7) {
         Component var8 = var1.getComponent(var7);
         if (var8.isVisible()) {
            int var9 = var8.size().height;
            var8.resize(var5 - var4, var9);
            Dimension var10 = var8.preferredSize();
            var8.reshape(var4, var3, var5 - var4, var10.height);
            var3 += var10.height + this.vgap;
         }
      }

   }

   public String toString() {
      return this.getClass().getName() + "[vgap=" + this.vgap + "]";
   }
}
