package sun.awt.macos;

import java.awt.Component;
import java.awt.MenuComponent;

public class InterfaceEvent {
   public static final int NONE = 0;
   public static final int EXPOSE = 1;
   public static final int REPAINT = 2;
   public static final int MOUSE_DOWN = 3;
   public static final int MOUSE_UP = 4;
   public static final int MOUSE_MOVED = 5;
   public static final int MOUSE_DRAGGED = 6;
   public static final int KEY_PRESS = 7;
   public static final int KEY_RELEASE = 8;
   public static final int KEY_ACTION = 9;
   public static final int KEY_ACTION_RELEASE = 10;
   public static final int MOUSE_ENTER = 11;
   public static final int MOUSE_EXIT = 12;
   public static final int ACTION_VOID = 13;
   public static final int ACTION_BOOL = 14;
   public static final int ACTION_INT = 15;
   public static final int ACTION_MENU = 16;
   public static final int LIST_SELECT = 17;
   public static final int LIST_DESELECT = 18;
   public static final int kRepaintsBetweenSleeps = 2;
   static InterfaceEvent gFirstInterfaceEvent = null;
   static InterfaceEvent gLastInterfaceEvent = null;
   static Thread mInterfaceThread = null;
   static int gCountTilSleep = 2;
   InterfaceEvent next = null;
   InterfaceEvent prev = null;
   int type;
   Component component;
   MenuComponent menuComponent;
   // $FF: renamed from: x int
   int field_0;
   // $FF: renamed from: y int
   int field_1;
   int width;
   int height;
   long when;
   int flags;
   int key;
   int clickCount;
   boolean actionState;
   int eventNumber;

   public InterfaceEvent(int var1, Component var2, MenuComponent var3, int var4, int var5, int var6, int var7, long var8, int var10, int var11, int var12, boolean var13, int var14) {
      this.component = var2;
      this.type = var1;
      this.width = var6;
      this.height = var7;
      this.field_0 = var4;
      this.field_1 = var5;
      this.when = var8;
      this.flags = var10;
      this.key = var11;
      this.clickCount = var12;
      this.actionState = var13;
      this.menuComponent = var3;
      this.eventNumber = var14;
   }

   public int getEventNumber() {
      return this.eventNumber;
   }

   public int getClickCount() {
      return this.clickCount;
   }

   public int getType() {
      return this.type;
   }

   public Component getComponent() {
      return this.component;
   }

   public MenuComponent getMenuComponent() {
      return this.menuComponent;
   }

   public int getKey() {
      return this.key;
   }

   public long getWhen() {
      return this.when;
   }

   public int getFlags() {
      return this.flags;
   }

   public int getX() {
      return this.field_0;
   }

   public int getY() {
      return this.field_1;
   }

   public int getWidth() {
      return this.width;
   }

   public int getHeight() {
      return this.height;
   }

   public boolean getActionState() {
      return this.actionState;
   }

   public boolean enqueue() {
      if (this.type == 2 || this.type == 1) {
         for(InterfaceEvent var1 = gLastInterfaceEvent; var1 != null; var1 = var1.next) {
            if (var1.getType() == this.type && var1.getComponent() == this.getComponent()) {
               if (this.field_0 < var1.field_0) {
                  var1.width += var1.field_0 - this.field_0;
                  var1.field_0 = this.field_0;
               }

               if (this.field_1 < var1.field_1) {
                  var1.height += var1.field_1 - this.field_1;
                  var1.field_1 = this.field_1;
               }

               if (this.field_0 + this.width > var1.field_0 + var1.width) {
                  var1.width = this.field_0 + this.width - var1.field_0;
               }

               if (this.field_1 + this.height > var1.field_1 + var1.height) {
                  var1.height = this.field_1 + this.height - var1.field_1;
               }

               return false;
            }
         }

         if (this.type == 2) {
            try {
               if (gCountTilSleep == 0) {
                  Thread.currentThread();
                  Thread.sleep(15L);
                  gCountTilSleep = 2;
               } else {
                  --gCountTilSleep;
               }
            } catch (InterruptedException var2) {
            }
         }
      }

      this.next = null;
      this.prev = gLastInterfaceEvent;
      if (gLastInterfaceEvent != null) {
         gLastInterfaceEvent.next = this;
      }

      gLastInterfaceEvent = this;
      if (gFirstInterfaceEvent == null) {
         gFirstInterfaceEvent = this;
      }

      return true;
   }

   public void dequeue() {
      if (this.next != null) {
         this.next.prev = this.prev;
      } else {
         gLastInterfaceEvent = this.prev;
      }

      if (this.prev != null) {
         this.prev.next = this.next;
      } else {
         gFirstInterfaceEvent = this.next;
      }
   }

   public static InterfaceEvent firstEvent() {
      return gFirstInterfaceEvent;
   }

   public static void flushInterfaceQueue(MComponentPeer var0) {
      for(InterfaceEvent var1 = gFirstInterfaceEvent; var1 != null; var1 = var1.next) {
         if (var1.component == var0.target) {
            if (var1.prev == null) {
               gFirstInterfaceEvent = var1.next;
            } else {
               var1.prev.next = var1.next;
            }

            if (var1.next == null) {
               gLastInterfaceEvent = var1.prev;
            } else {
               var1.next.prev = var1.prev;
            }
         }
      }

   }
}
