package sun.awt.macos;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Image;
import java.awt.MenuBar;
import java.awt.Rectangle;
import java.awt.Window;
import java.awt.event.ComponentEvent;
import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;
import java.awt.peer.ComponentPeer;
import java.awt.peer.FramePeer;
import java.awt.peer.LightweightPeer;
import netscape.applet.AppletServices;
import sun.awt.ScreenUpdater;

class MFramePeer extends MPanelPeer implements FramePeer {
   boolean mFrameIsSecure;
   boolean mFrameIsEmbedded;
   boolean mIsWindow;
   MFramePeer mHostPeer;

   MFramePeer(Frame var1) {
      super(var1);
      this.mIsWindow = false;
      AppletServices.addTopLevelWindow(var1, Thread.currentThread().getThreadGroup());
      if (var1.getTitle() != null) {
         this.setTitle(var1.getTitle());
      }

      Font var2 = ((Component)var1).getFont();
      if (var2 == null) {
         var2 = new Font("Dialog", 0, 9);
         ((Component)var1).setFont(var2);
         ((MComponentPeer)this).setFont(var2);
      }

      Color var3 = ((Component)var1).getBackground();
      if (var3 == null) {
         ((Component)var1).setBackground(Color.lightGray);
         ((MComponentPeer)this).setBackground(Color.lightGray);
      }

      var3 = ((Component)var1).getForeground();
      if (var3 == null) {
         ((Component)var1).setForeground(Color.black);
         ((MComponentPeer)this).setForeground(Color.black);
      }

      Image var4 = var1.getIconImage();
      if (var4 != null) {
         this.setIconImage(var4);
      }

      this.setResizable(var1.isResizable());
      Rectangle var5 = ((Component)var1).bounds();
      this.reshape(var5.x, var5.y, var5.width, var5.height);
   }

   MFramePeer(Window var1) {
      super(var1);
      this.mIsWindow = true;
      AppletServices.addTopLevelWindow(var1, Thread.currentThread().getThreadGroup());
      Font var2 = ((Component)var1).getFont();
      if (var2 == null) {
         var2 = new Font("Dialog", 0, 9);
         ((Component)var1).setFont(var2);
         ((MComponentPeer)this).setFont(var2);
      }

      Color var3 = ((Component)var1).getBackground();
      if (var3 == null) {
         ((Component)var1).setBackground(Color.lightGray);
         ((MComponentPeer)this).setBackground(Color.lightGray);
      }

      var3 = ((Component)var1).getForeground();
      if (var3 == null) {
         ((Component)var1).setForeground(Color.black);
         ((MComponentPeer)this).setForeground(Color.black);
      }

      this.setResizable(false);
      Rectangle var4 = ((Component)var1).bounds();
      this.reshape(var4.x, var4.y, var4.width, var4.height);
   }

   native void create(MComponentPeer var1);

   ComponentPeer getFocusPeer() {
      for(Object var1 = ((Window)super.target).getFocusOwner(); var1 != null; var1 = ((Component)var1).getParent()) {
         ComponentPeer var2 = ((Component)var1).getPeer();
         if (var2 != null) {
            return var2;
         }
      }

      return null;
   }

   MComponentPeer setDefaultFocus() {
      Component var1 = this.setDefaultFocus((Container)super.target);
      Component var2;
      if (var1 == null) {
         for(var1 = super.target; var1 instanceof Container && ((Container)var1).getComponentCount() > 0 && var1.getPeer() != null; var1 = var2) {
            var2 = ((Container)var1).getComponent(0);
            if (!var2.isVisible() || !var2.isEnabled()) {
               break;
            }
         }
      }

      ComponentPeer var3 = var1.getPeer();
      if (var3 instanceof LightweightPeer) {
         var1.requestFocus();
         return null;
      } else {
         return (MComponentPeer)var3;
      }
   }

   private Component setDefaultFocus(Container var1) {
      int var2 = var1.getComponentCount();

      for(int var3 = 0; var3 < var2; ++var3) {
         Component var4 = var1.getComponent(var3);
         if (var4.isVisible() && var4.isEnabled() && var4.isFocusTraversable()) {
            return var4;
         }

         if (var4 instanceof Container && var4.isVisible() && var4.isEnabled()) {
            Component var5 = this.setDefaultFocus((Container)var4);
            if (var5 != null) {
               return var5;
            }
         }
      }

      return null;
   }

   protected void sendKeyEvent(int var1, int var2, int var3, int var4, int var5, boolean var6, int var7) {
      Component var8 = ((Window)super.target).getFocusOwner();
      if (var8 != null) {
         long var9 = 0L;
         int var11 = MComponentPeer.modifiersToJavaFlags(var5);
         char var14 = (char)var4;
         var9 = System.currentTimeMillis();
         short var12;
         if (var6) {
            var12 = 401;
         } else {
            var12 = 402;
         }

         KeyEvent var15 = new KeyEvent(var8, var12, var9, var11, var3, var14);
         MToolkit.addNativeEventInfo(var15, var7);
         MToolkit.postEvent(var15);
         if (var6 && var14 != 0) {
            var12 = 400;
            var15 = new KeyEvent(var8, var12, var9, var11, 0, var14);
            MToolkit.addNativeEventInfo(var15, var7);
            MToolkit.postEvent(var15);
         }
      }

   }

   public native void setTitle(String var1);

   public void show() {
      super.show();
      this.pShow();
   }

   public void reshape(int var1, int var2, int var3, int var4) {
      this.pReshape(var1, var2, var3, var4);
   }

   public void setIconImage(Image var1) {
   }

   public void setMenuBar(MenuBar var1) {
   }

   public void setResizable(boolean var1) {
   }

   public void dispose() {
      AppletServices.removeTopLevelWindow((Window)super.target, Thread.currentThread().getThreadGroup());
      MToolkit.targetDisposedPeer(super.target, this);
      ScreenUpdater.updater.removeClient(this);
      this.pDispose();
   }

   private native void pReshape(int var1, int var2, int var3, int var4);

   private native void pDispose();

   private native void pShow();

   protected void handleFrameReshape(int var1, int var2, int var3, int var4) {
      super.target.reshape(var1, var2, var3, var4);
      super.target.invalidate();
      super.target.validate();
      super.target.repaint();
   }

   protected void handleWindowClose() {
      MToolkit.postEvent(new WindowEvent((Window)super.target, 201));
   }

   protected void handleWindowClosed() {
      MToolkit.postEvent(new WindowEvent((Window)super.target, 202));
   }

   protected void handleWindowActivate() {
      MToolkit.postEvent(new WindowEvent((Window)super.target, 205));
   }

   protected void handleWindowDeactivate() {
      MToolkit.postEvent(new WindowEvent((Window)super.target, 206));
   }

   protected void handleWindowMoved(int var1, int var2) {
      MToolkit.postEvent(new ComponentEvent(super.target, 100));
   }

   public native void toFront();

   public native void toBack();
}
