package sun.awt.windows;

import java.awt.Font;
import java.awt.MenuComponent;
import java.awt.MenuItem;
import java.awt.MenuShortcut;
import java.awt.event.ActionEvent;
import java.awt.peer.MenuItemPeer;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

class WMenuItemPeer extends WObjectPeer implements MenuItemPeer {
   String shortcutLabel;
   boolean isCheckbox = false;
   private static Font defaultMenuFont;

   public void dispose() {
      WToolkit.targetDisposedPeer(super.target, this);
      this._dispose();
   }

   public void setEnabled(boolean var1) {
      this.enable(var1);
   }

   public void enable() {
      this.enable(true);
   }

   public void disable() {
      this.enable(false);
   }

   public void setLabel(String var1) {
      if (!(this instanceof WPopupMenuPeer)) {
         MenuShortcut var2 = ((MenuItem)super.target).getShortcut();
         this.shortcutLabel = var2 != null ? var2.toString() : null;
         this._setLabel(var1);
      }
   }

   public native void _setLabel(String var1);

   protected WMenuItemPeer() {
   }

   WMenuItemPeer(MenuItem var1) {
      super.target = var1;
      WMenuPeer var2 = (WMenuPeer)WToolkit.targetToPeer(((MenuComponent)var1).getParent());
      this.create(var2);
      MenuShortcut var3 = var1.getShortcut();
      if (var3 != null) {
         this.shortcutLabel = var3.toString();
      }

   }

   native void create(WMenuPeer var1);

   native void enable(boolean var1);

   public native void _dispose();

   protected void finalize() throws Throwable {
      this._dispose();
      super.finalize();
   }

   void handleAction(int var1) {
      WToolkit.postEvent(new ActionEvent(super.target, 1001, ((MenuItem)super.target).getActionCommand(), var1));
   }

   Font getDefaultFont() {
      return defaultMenuFont;
   }

   static {
      try {
         ResourceBundle var0 = ResourceBundle.getBundle("sun.awt.windows.awtLocalization");
         defaultMenuFont = Font.decode(var0.getString("menuFont"));
      } catch (MissingResourceException var1) {
         System.out.println(((Throwable)var1).getMessage());
         System.out.println("Using default MenuItem font\n");
         defaultMenuFont = new Font("SanSerif", 0, 11);
      }
   }
}
