package sun.awt.windows;

import java.awt.Component;
import java.awt.Container;
import java.awt.Font;
import java.awt.Insets;
import java.awt.Window;
import java.awt.peer.ComponentPeer;
import java.awt.peer.LightweightPeer;
import java.awt.peer.WindowPeer;
import java.util.Vector;
import netscape.applet.AppletServices;

class WWindowPeer extends WPanelPeer implements WindowPeer {
   static Vector allWindows = new Vector();

   public void dispose() {
      allWindows.removeElement(this);
      AppletServices.removeTopLevelWindow((Window)super.target, Thread.currentThread().getThreadGroup());
      super.dispose();
   }

   protected void destroy() {
      super.destroy();
      allWindows.removeElement(this);
   }

   public native void toFront();

   public native void toBack();

   public void setTitle(String var1) {
      if (var1 == null) {
         var1 = new String("");
      }

      this._setTitle(var1);
   }

   native void _setTitle(String var1);

   public void setResizable(boolean var1) {
      this._setResizable(var1);
      ((Component)super.target).invalidate();
   }

   public native void _setResizable(boolean var1);

   WWindowPeer(Window var1) {
      super(var1);
      AppletServices.addTopLevelWindow(var1, Thread.currentThread().getThreadGroup());
   }

   void initialize() {
      super.initialize();
      this.updateInsets(super.insets_);
      allWindows.addElement(this);
      Font var1 = ((Window)super.target).getFont();
      if (var1 == null) {
         var1 = new Font("Dialog", 0, 12);
         ((Window)super.target).setFont(var1);
         ((WComponentPeer)this).setFont(var1);
      }

   }

   native void create(WComponentPeer var1);

   native void updateInsets(Insets var1);

   ComponentPeer getFocusPeer() {
      for(Object var1 = ((Window)super.target).getFocusOwner(); var1 != null; var1 = ((Component)var1).getParent()) {
         ComponentPeer var2 = ((Component)var1).getPeer();
         if (var2 != null) {
            return var2;
         }
      }

      return null;
   }

   WComponentPeer setDefaultFocus() {
      Component var1 = this.setDefaultFocus((Container)super.target);
      Component var2;
      if (var1 == null) {
         for(var1 = (Component)super.target; var1 instanceof Container && ((Container)var1).getComponentCount() > 0 && var1.getPeer() != null; var1 = var2) {
            var2 = this.getContainerElement((Container)var1, 0);
            if (!var2.isVisible() || !var2.isEnabled()) {
               break;
            }
         }
      }

      ComponentPeer var3 = var1.getPeer();
      if (var3 instanceof LightweightPeer) {
         var1.requestFocus();
         return null;
      } else {
         return (WComponentPeer)var3;
      }
   }

   private Component setDefaultFocus(Container var1) {
      int var2 = var1.getComponentCount();

      for(int var3 = 0; var3 < var2; ++var3) {
         Component var4 = this.getContainerElement(var1, var3);
         if (var4.isVisible() && var4.isEnabled() && var4.isFocusTraversable()) {
            return var4;
         }

         if (var4 instanceof Container && var4.isVisible() && var4.isEnabled()) {
            Component var5 = this.setDefaultFocus((Container)var4);
            if (var5 != null) {
               return var5;
            }
         }
      }

      return null;
   }

   private native Component getContainerElement(Container var1, int var2);
}
